//
// Base styles
//

.btn {
    outline: none;
    cursor: pointer;
    font-weight: 400;
    font-size: rem(14);
    min-height: rem(44);
    min-width: rem(160);
    line-height: rem(20);
    padding: rem(4) rem(16);
    user-select: none;
    text-align: center;
    white-space: nowrap;
    position: relative;
    text-decoration: none;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    column-gap: rem(4);
    vertical-align: middle;
    border: rem(1) solid;
    border-radius: rem(10);
    transition: var(--transition-time);

    &:hover {
        text-decoration: none;
        transition: var(--transition-time);
    }

    &:active {

    }

    &:focus,
    &.focus {
        outline: 0;
    }

    span {
        display: inline-block;
    }

    i {
        font-size: 0;
        line-height: 0;
        display: inline-block;
        height: rem(18);

        &.icon-plus {
            height: rem(14);
        }
    }

    @include media-breakpoint-up(xl) {
        min-height: rem(52);
        padding: rem(4) rem(24);
    }
}

.btn-primary {
    fill: white;
    color: white;
    stroke: white;
    background: var(--blue);
    border-color: var(--blue);

    &:hover {
        fill: white;
        color: white;
        stroke: white;
        background: var(--blue-hover);
        border-color: var(--blue-hover);
    }

    &:active {
        background: var(--blue);
        border-color: var(--blue);
    }
}

.btn-outline-primary {
    fill: var(--blue);
    color: var(--blue);
    stroke: var(--blue);
    background: transparent;
    border-color: var(--blue);

    &:hover {
        fill: white;
        color: white;
        stroke: white;
        background: var(--blue);
        border-color: var(--blue);
    }

    &:active {
        fill: var(--blue);
        color: var(--blue);
        stroke: var(--blue);
        background: transparent;
        border-color: var(--blue);
    }
}

.btn-white {
    fill: var(--dark);
    color: var(--dark);
    stroke: var(--dark);
    background: white;
    border-color: white;

    &:hover {
        fill: var(--dark);
        color: var(--dark);
        stroke: var(--dark);
        background: rgba(1, 118, 246, 0.1);
        border-color: rgba(1, 118, 246, 0.1);
    }

    &:active {
        background: rgba(1, 118, 246, 0.2);
        border-color: rgba(1, 118, 246, 0.2);
    }

    &.active {
        fill: white;
        color: white;
        stroke: white;
        background: var(--blue);
        border-color: var(--blue);
    }
}

.btn-rounded {
    border-radius: rem(30);
}


.btn-xs {
    min-width: inherit;
    min-height: rem(36);
    padding: rem(4) rem(12);
}

.btn-sm {
    min-height: rem(44);
}

.btn-medium {
    min-width: rem(190);
}

.btn-long {
    min-width: rem(200);
}

//
// Alternate buttons
//

// scss-docs-start btn-variant-loops
@each $color, $value in $theme-colors {
  .btn-#{$color} {
    @if $color == "light" {
      @include button-variant(
        $value,
        $value,
        $hover-background: shade-color($value, $btn-hover-bg-shade-amount),
        $hover-border: shade-color($value, $btn-hover-border-shade-amount),
        $active-background: shade-color($value, $btn-active-bg-shade-amount),
        $active-border: shade-color($value, $btn-active-border-shade-amount)
      );
    } @else if $color == "dark" {
      @include button-variant(
        $value,
        $value,
        $hover-background: tint-color($value, $btn-hover-bg-tint-amount),
        $hover-border: tint-color($value, $btn-hover-border-tint-amount),
        $active-background: tint-color($value, $btn-active-bg-tint-amount),
        $active-border: tint-color($value, $btn-active-border-tint-amount)
      );
    } @else {
      @include button-variant($value, $value);
    }
  }
}

@each $color, $value in $theme-colors {
  .btn-outline-#{$color} {
    @include button-outline-variant($value);
  }
}
// scss-docs-end btn-variant-loops


//
// Link buttons
//

// Make a button look and behave like a link
.btn-link {
  --#{$prefix}btn-font-weight: #{$font-weight-normal};
  --#{$prefix}btn-color: #{$btn-link-color};
  --#{$prefix}btn-bg: transparent;
  --#{$prefix}btn-border-color: transparent;
  --#{$prefix}btn-hover-color: #{$btn-link-hover-color};
  --#{$prefix}btn-hover-border-color: transparent;
  --#{$prefix}btn-active-color: #{$btn-link-hover-color};
  --#{$prefix}btn-active-border-color: transparent;
  --#{$prefix}btn-disabled-color: #{$btn-link-disabled-color};
  --#{$prefix}btn-disabled-border-color: transparent;
  --#{$prefix}btn-box-shadow: 0 0 0 #000; // Can't use `none` as keyword negates all values when used with multiple shadows
  --#{$prefix}btn-focus-shadow-rgb: #{$btn-link-focus-shadow-rgb};

  text-decoration: $link-decoration;
  @if $enable-gradients {
    background-image: none;
  }

  &:hover,
  &:focus-visible {
    text-decoration: $link-hover-decoration;
  }

  &:focus-visible {
    color: var(--#{$prefix}btn-color);
  }

  &:hover {
    color: var(--#{$prefix}btn-hover-color);
  }

  // No need for an active state here
}


//
// Button Sizes
//

.btn-lg {
  min-height: rem(48);
}

.btn-sm {
  @include button-size($btn-padding-y-sm, $btn-padding-x-sm, $btn-font-size-sm, $btn-border-radius-sm);
}
